/* This file was generated by plugin 'Nordic Semiconductor nRF5x v.1.2.2' (BDS version 1.1.3139.0) */

#ifndef BLE_FAS_H__
#define BLE_FAS_H__

#include <stdint.h>
#include <stdbool.h>
#include "ble.h"
#include "ble_srv_common.h"
#include "app_util_bds.h"

//#define AUTHENTICATION_FEATURE_ENABLED

#define BLE_FAS_BASE_UUID               0xFF60
#define BLE_FAS_UUID_RAND_NUM_CLR       0xFF61
#define BLE_FAS_UUID_CIPHOR_WRITE       0xFF62

//#ifdef AUTHENTICATION_FEATURE_ENABLED
//#define CLEAR_CHAR 			1
//#define CIPHER_CHAR 		2
//
//typedef void (*authCallbackType)(bool);
//#endif

/**@brief FAS event type. */
typedef enum
{ 
    BLE_FAS_RANDOMNUMBERCLEAR_EVT_NOTIFICATION_ENABLED,  /**< RandomNumberClear value notification enabled event. */
    BLE_FAS_RANDOMNUMBERCLEAR_EVT_NOTIFICATION_DISABLED, /**< RandomNumberClear value notification disabled event. */
    BLE_FAS_RANDOMNUMBERCLEAR_EVT_WRITE, /**< RandomNumberClear write event. */
    BLE_FAS_RANDOMNUMBERCIPHER_EVT_NOTIFICATION_ENABLED,  /**< RandomNumberCipher value notification enabled event. */
    BLE_FAS_RANDOMNUMBERCIPHER_EVT_NOTIFICATION_DISABLED, /**< RandomNumberCipher value notification disabled event. */
    BLE_FAS_RANDOMNUMBERCIPHER_EVT_WRITE /**< RandomNumberCipher write event. */
} ble_fas_evt_type_t;

// Forward declaration of the ble_fas_t type.
typedef struct ble_fas_s ble_fas_t;


/**@brief RandomNumberClear structure. */
typedef struct
{
    uint16_t random_num_generated;
} ble_fas_randomnumberclear_t;
/**@brief RandomNumberCipher structure. */
typedef struct
{
    uint16_t aes_ecb_encrypted_value;
} ble_fas_randomnumbercipher_t;

/**@brief FAS Service event. */
typedef struct
{
    ble_fas_evt_type_t evt_type;    /**< Type of event. */
//#ifdef AUTHENTICATION_FEATURE_ENABLED
//    uint8_t characteristic;
//#endif
    union {
        uint16_t cccd_value; /**< Holds decoded data in Notify and Indicate event handler. */
        ble_fas_randomnumberclear_t randomnumberclear; /**< Holds decoded data in Write event handler. */
        ble_fas_randomnumbercipher_t randomnumbercipher; /**< Holds decoded data in Write event handler. */
    } params;
} ble_fas_evt_t;

/**@brief FAS Service event handler type. */
typedef void (*ble_fas_evt_handler_t) (ble_fas_t * p_fas, ble_fas_evt_t * p_evt);

/**@brief FAS Service init structure. This contains all options and data needed for initialization of the service */
typedef struct
{
    ble_fas_evt_handler_t     evt_handler; /**< Event handler to be called for handling events in the FAS Service. */
    ble_fas_randomnumberclear_t ble_fas_randomnumberclear_initial_value; /**< If not NULL, initial value of the RandomNumberClear characteristic. */ 
    ble_fas_randomnumbercipher_t ble_fas_randomnumbercipher_initial_value; /**< If not NULL, initial value of the RandomNumberCipher characteristic. */ 
} ble_fas_init_t;

/**@brief FAS Service structure. This contains various status information for the service.*/
struct ble_fas_s
{
    ble_fas_evt_handler_t evt_handler; /**< Event handler to be called for handling events in the FAS Service. */
    uint16_t service_handle; /**< Handle of FAS Service (as provided by the BLE stack). */
    ble_gatts_char_handles_t randomnumberclear_handles; /**< Handles related to the RandomNumberClear characteristic. */
    ble_gatts_char_handles_t randomnumbercipher_handles; /**< Handles related to the RandomNumberCipher characteristic. */
    uint16_t conn_handle; /**< Handle of the current connection (as provided by the BLE stack, is BLE_CONN_HANDLE_INVALID if not in a connection). */
};

/**@brief Function for initializing the FAS.
 *
 * @param[out]  p_fas       FAS Service structure. This structure will have to be supplied by
 *                          the application. It will be initialized by this function, and will later
 *                          be used to identify this particular service instance.
 * @param[in]   p_fas_init  Information needed to initialize the service.
 *
 * @return      NRF_SUCCESS on successful initialization of service, otherwise an error code.
 */
uint32_t ble_fas_init(ble_fas_t * p_fas, const ble_fas_init_t * p_fas_init);

/**@brief Function for handling the Application's BLE Stack events.*/
void ble_fas_on_ble_evt(ble_fas_t * p_fas, ble_evt_t * p_ble_evt);

/**@brief Function for setting the RandomNumberClear.
 *
 * @details Sets a new value of the RandomNumberClear characteristic. The new value will be sent
 *          to the client the next time the client reads the RandomNumberClear characteristic.
 *          This function is only generated if the characteristic's Read property is not 'Excluded'.
 *
 * @param[in]   p_fas                 FAS Service structure.
 * @param[in]   p_randomnumberclear  New RandomNumberClear.
 *
 * @return      NRF_SUCCESS on success, otherwise an error code.
 */
uint32_t ble_fas_randomnumberclear_set(ble_fas_t * p_fas, ble_fas_randomnumberclear_t * p_randomnumberclear);

#endif //_BLE_FAS_H__
